const dryRun = false;
const debugLog = true;
var difficulty=3; 
var maxWaveTime = 1;
var waveTime = () => randFloat(0.1, 0.5) * maxWaveTime;
var initialAttackers = 5;
var percentPerMinute = 1.05;
var ccAttackerInterval = t => randFloat(1, 2);
var totalAttackerLimit = 200;
var gaulPlayer = 0;
var triggerPointShipSpawn = "A";
var triggerPointShipPatrol = "B";
var triggerPointUngarrisonLeft = "C";
var triggerPointUngarrisonRight = "D";
var triggerPointLandPatrolLeft = "E";
var triggerPointLandPatrolRight = "F";
var triggerPointCCAttackerPatrolLeft = "G";
var triggerPointCCAttackerPatrolRight = "H";
var triggerPointRiverDirection = "I";
var heroTime = () => randFloat(20, 60);
var mapBounds={};
var tile_d=[];

var disabledTemplates = (civ) => [
	// Economic structures
	"structures/" + civ + "_farmstead",
	"structures/" + civ + "_field",
	"structures/" + civ + "_market",
	"structures/" + civ + "_temple",
	"structures/" + civ + "_rotarymill",
	"units/maur_support_elephant",

	// Expansions
	"structures/" + civ + "_civil_centre",
	"structures/" + civ + "_military_colony",

	// Walls
	"structures/" + civ + "_wallset_stone",
	"structures/rome_wallset_siege",
	"other/wallset_palisade",
	"other/forestry",
	"other/MinistryofEconomy",

	// Shoreline
	"structures/" + civ + "_dock",
	"structures/brit_crannog",
	"structures/cart_super_dock",
	"structures/ptol_lighthouse"
];

var formationProbability = 0.2;

var unitFormations = [
	"special/formations/box",
	"special/formations/box",
	"special/formations/box",
	"special/formations/battle_line",
	"special/formations/line_closed",
	"special/formations/line_open",
	"special/formations/flank"
];

var unitFormations2 = [
	"special/formations/box",
	"special/formations/battle_line",
	"special/formations/null",
	"special/formations/null",
	"special/formations/null",
	"special/formations/null",
	"special/formations/null",
	"special/formations/null",
	"special/formations/flank"
];
var triggerPointShipSpawn = "A";
var unitTargetClass = "Unit+!Ship";
var healerRatio=0.01;
var heroProbability = t => Math.max(0, Math.min(1, (t - 25) / 60));
var numPlayers = Engine.QueryInterface(SYSTEM_ENTITY, IID_PlayerManager).GetActivePlayers().length;
var AttackTempl1=["units/maur_champion_elephant"];
var AttackTempl3=["units/gaul_champion_fanatic","units/ptol_champion_cavalry","units/brit_champion_cavalry","units/infantry_champion_swordsman","units/maur_champion_elephant"];
var AttackTempl=["units/mace_infantry_pikeman_e","units/cart_infantry_spearman_e","units/ptol_infantry_swordsman_merc_e","units/infantry_champion_armbrust","units/ptol_infantry_javelinist_e"];
var AttackTempl4=["units/superman","units/ele_hero","units/hero_of_the_battlefield_archer","units/hero_of_the_battlefield","units/hero_of_the_battlefield_javel"];
var AttackTempl5=["units/merc_thureophoros","units/merc_thorakites","units/maur_champion_elephant","units/infantry_champion_pike","units/iber_champion_cavalry","units/iber_champion_infantry","units/pers_champion_infantry"];
var AttackTempl2=["units/gaul_cavalry_swordsman_e","units/ptol_cavalry_spearman_merc_e"];
var AttackTempl6=["units/ptol_mechanical_siege_lithobolos_unpacked","units/ptol_mechanical_siege_polybolos_unpacked","units/cavalry_champion_archer",];
var AttackTempl6=["units/superman","units/hero_of_the_battlefield_archer","units/hero_of_the_battlefield_javel"];
var AttackTempl_Cav=["units/ptol_champion_cavalry","units/gaul_cavalry_swordsman_e","units/pro_cavalry_champion_spearman","units/ptol_cavalry_spearman_merc_e"];
var AttackTempl_Spear=["units/mace_infantry_pikeman_e","units/cart_infantry_spearman_e"];
var AttackTempl_Ranged=["units/ptol_infantry_javelinist_e","units/ptol_infantry_archer_e"];
var L_entities=[];


var AttackTempl1=["units/pro_cavalry_champion_swordsman","units/pro_cavalry_champion_spearman","units/maur_champion_elephant","units/pro_infantry_champion_armbrust"];
var AttackTempl3=["units/gaul_champion_fanatic","units/pro_infantry_champion_swordsman"];
var AttackTempl=["units/mace_infantry_pikeman_e","units/cart_infantry_spearman_e","units/ptol_infantry_swordsman_merc_e"];
var AttackTempl4=["units/superman","units/ele_hero","units/hero_of_the_battlefield_archer","units/hero_of_the_battlefield","units/hero_of_the_battlefield_javel"];
var AttackTempl5=["units/merc_thureophoros","units/merc_thorakites"];
var AttackTempl7=["units/ptol_mechanical_siege_lithobolos_unpacked","units/ptol_mechanical_siege_polybolos_unpacked","units/pro_cavalry_champion_archer"];
var AttackTempl6=["units/hero_of_the_battlefield_archer","units/hero_of_the_battlefield_javel"];
var AttackTempl2=["units/ptol_cavalry_spearman_merc_e","units/ptol_infantry_javelinist_e"];
var AttackTempl_=[];
AttackTempl_.concat( AttackTempl2);

var AttackTempl1_=[];
AttackTempl1_.concat(AttackTempl3, AttackTempl4,  AttackTempl6,AttackTempl7);

/* TriggerHelper.GetLandSpawnPoints 
TriggerHelper.GetPlayerEntitiesByClass = function(playerID, classes)
TriggerHelper.SpawnUnitsFromTriggerPoints = function(ref, template, count, owner = null)

TriggerHelper.GetEntitiesByPlayer
*/
let D_types={};
var L_entities_pl=[];
var D_entities_pl=[];
let typesU=["RI","RC","WI","SI","MC","EL","SG"];//Ranged Inf,Ranged Cav,sword spear,Ele,Siege
let strength=[1,2,3,4,5,6];//Ranged Inf,Ranged Cav,sword spear,Ele,Siege
for (let plid=0;plid<numPlayers+1;plid++){
	D_entities_pl[plid+"_"+typesU+"_"+strength]=[];
	 L_entities_pl[plid]=[];
}

Trigger.prototype.SpawnCCAttackers2 = function()
{
	let time = TriggerHelper.GetMinutes();
	//TriggerHelper.SpawnUnits(this.tower, pickRandom(AttackTempl),2, gaulPlayer);
	//TriggerHelper.SpawnUnits(this.Fortress, pickRandom(AttackTempl),2, gaulPlayer);
	let ccs_alive=0;
	var ccAttackerCount = t => Math.min(24*(numPlayers*0.8)*(difficulty*0.4), Math.max(10, Math.round((t*0.5)*(numPlayers*0.8)*(difficulty*0.3333) * 15.5)));
	for (let gaiaCC of this.civicCenters)
	
	
	{	
		ccs_alive+=1
		/* if (!TriggerHelper.IsInWorld(gaiaCC))
			continue; */
		let ccAttackers = [];
		var templ=pickRandom(AttackTempl);
		var templ1=pickRandom(AttackTempl1);
		var templ2=pickRandom(AttackTempl2);
		var templ3=pickRandom(AttackTempl3);
		var templ4=pickRandom(AttackTempl4);
		var templ5=pickRandom(AttackTempl5);
		var count=ccAttackerCount(time);
		count=10;
		
		let type_str="";
		let ents = TriggerHelper.SpawnUnits(gaiaCC, templ,count, gaulPlayer);
		//TriggerHelper.SetUnitFormation(gaulPlayer, ents, pickRandom(unitFormations));
		/* type_str=D_types[templ];
		D_entities_pl[0+type_str].push(ents); */
		let ents1 = TriggerHelper.SpawnUnits(gaiaCC, templ1,count, gaulPlayer);

		let ents2 = TriggerHelper.SpawnUnits(gaiaCC, templ2,Math.round(count/ 2), gaulPlayer);

		let ents3 = TriggerHelper.SpawnUnits(gaiaCC, templ3,Math.round(count/ 3), gaulPlayer);

		let ents4 = TriggerHelper.SpawnUnits(gaiaCC, templ4,Math.round(count/ 4), gaulPlayer);

		let ents5 = TriggerHelper.SpawnUnits(gaiaCC, templ5,Math.round(count/ 4), gaulPlayer);
		
		
		
		ccAttackers = ccAttackers.concat(ents);
		ccAttackers = ccAttackers.concat(ents1);
		ccAttackers = ccAttackers.concat(ents3);
		ccAttackers = ccAttackers.concat(ents2);
		ccAttackers = ccAttackers.concat(ents4);
		ccAttackers = ccAttackers.concat(ents5);
		L_entities.push(ccAttackers);
		
		
		var p=	TriggerHelper.GetLandSpawnPoints();
		TriggerHelper.SetUnitFormation(gaulPlayer, ccAttackers , pickRandom(unitFormations));
		let patrolPointRef = triggerPointCCAttackerPatrolLeft
		this.AttackAndPatrol(ccAttackers, unitTargetClass, patrolPointRef, "CCAttackers", true);
	}

	if (ccs_alive==0)
		TriggerHelper.SetPlayerWon(1)
};
Trigger.prototype.SpawnCCPlayer = function(playerNr)
{
	let time = TriggerHelper.GetMinutes();
	let numPlayers = Engine.QueryInterface(SYSTEM_ENTITY, IID_PlayerManager).GetActivePlayers().length;
	if (playerNr==0) return;
	log("playerNr"+playerNr);
	print (playerNr);
	//print (JSON.stringify(D_entities_pl));
	//print (JSON.stringify(D_entities_pl[playerNr+"_RI_1"]));
	//print (this.civicCentersplayers);
	
	for (let gaiaCC of this.civicCentersplayers[playerNr])
	{
		/* if (!TriggerHelper.IsInWorld(gaiaCC))
			continue; */
		
		let ents = TriggerHelper.SpawnUnits(gaiaCC, "units/superman",1, playerNr);
		// ents = TriggerHelper.SpawnUnits(gaiaCC, "units/infantry_champion_swordsman",1, playerNr);
		// ents = TriggerHelper.SpawnUnits(gaiaCC, "units/infantry_champion_spearman",1, playerNr);
		// ents = TriggerHelper.SpawnUnits(gaiaCC, "units/infantry_champion_armbrust",1, playerNr);
		// ents = TriggerHelper.SpawnUnits(gaiaCC, "units/cavalry_champion_javelinist",1, playerNr);
		// ents = TriggerHelper.SpawnUnits(gaiaCC, "units/cavalry_champion_archer",1, playerNr);
		// ents = TriggerHelper.SpawnUnits(gaiaCC, "units/cavalry_champion_swordsman",1, playerNr);
		// ents = TriggerHelper.SpawnUnits(gaiaCC, "units/hero_of_the_battlefield",1, playerNr);
		// ents = TriggerHelper.SpawnUnits(gaiaCC, "units/maur_champion_elephant",2, playerNr);
		// ents = TriggerHelper.SpawnUnits(gaiaCC, "units/hero_of_the_battlefield_cav",1, playerNr);
		// ents = TriggerHelper.SpawnUnits(gaiaCC, "units/hero_of_the_battlefield_archer",1, playerNr);
		// TriggerHelper.SpawnUnits(gaiaCC, "units/merc_thureophoros",1, playerNr);
		// TriggerHelper.SpawnUnits(gaiaCC, "units/merc_thorakites",1, playerNr);
		
		 //TriggerHelper.SpawnUnits(gaiaCC, "units/brit_champion_cavalry",10, playerNr);
		ents=TriggerHelper.SpawnUnits(gaiaCC, "units/ptol_infantry_archer_e",10, playerNr);
		L_entities_pl[playerNr].push(ents);
		
		//D_entities_pl[playerNr+"_RI_1"].push(ents);
		ents=TriggerHelper.SpawnUnits(gaiaCC, "units/ptol_infantry_javelinist_e",10, playerNr);
		L_entities_pl[playerNr].push(ents);
		ents=TriggerHelper.SpawnUnits(gaiaCC, "units/ptol_infantry_pikeman_e",10,playerNr);
		L_entities_pl[playerNr].push(ents);
		TriggerHelper.SpawnUnits(gaiaCC, "units/ptol_infantry_spearman_merc_e",10,playerNr);
		//TriggerHelper.SpawnUnits(gaiaCC, "units/ptol_infantry_swordsman_merc_e",10,playerNr);
		ents=TriggerHelper.SpawnUnits(gaiaCC, "units/ptol_cavalry_spearman_merc_e",10, playerNr);
		ents=TriggerHelper.SpawnUnits(gaiaCC, "units/gaul_cavalry_swordsman_e",10, playerNr);
		L_entities_pl[playerNr].push(ents);
		//TriggerHelper.SpawnUnits(gaiaCC, "units/ptol_cavalry_javelinist_merc_e",20,playerNr);
		//TriggerHelper.SetUnitFormation(1, ents, pickRandom(unitFormations));
		
		//ents = TriggerHelper.SpawnUnits(gaiaCC, "units/gaul_champion_infantry",10, playerNr);
		L_entities_pl[playerNr].push(ents);

		
	}

	
};

Trigger.prototype.InitSurvival = function()
{
	let time = TriggerHelper.GetMinutes();
	print ("InitSurvival");
	this.SetDisableTemplates();
	difficulty=this.GetDifficulty();
	this.civicCenters = new Set(TriggerHelper.GetPlayerEntitiesByClass(gaulPlayer, "CivCentre"));
	this.civicCentersplayers = [];
	
	var houses=TriggerHelper.GetPlayerEntitiesByClass(0, "House");
	print ("houses "+houses);
	
	this.civicCentersplayer=new Set(TriggerHelper.GetPlayerEntitiesByClass(ii+1, "CivCentre"));
	//print ("civicCentersplayers"+civicCentersplayers.length);
	this.tower =TriggerHelper.GetPlayerEntitiesByClass(gaulPlayer, "Defensive");
	this.tower2 = TriggerHelper.GetPlayerEntitiesByClass(gaulPlayer, "Fortress");

	//this.civicCenters = new Set(TriggerHelper.GetPlayerEntitiesByClass(gaulPlayer, "CivCentre"));
	
	
	
	
	for (var ii = 0; ii < numPlayers; ii++)
	{
		print ("spawn"+numPlayers+"  "+ii);
		this.civicCentersplayers.push(new Set(TriggerHelper.GetPlayerEntitiesByClass(ii, "CivCentre")));
//		TriggerHelper.HasDealtWithTech(ii, "fast_learner");
//		TriggerHelper.HasDealtWithTech(ii, "slow_infantry");
//		TriggerHelper.HasDealtWithTech(ii, "armor_infantry_01");
//		TriggerHelper.HasDealtWithTech(ii, "armor_infantry_02");
//		TriggerHelper.HasDealtWithTech(ii, "armor_cav_01");
//		TriggerHelper.HasDealtWithTech(ii, "armor_cav_02");
//		TriggerHelper.HasDealtWithTech(ii, "attack_infantry_hack_01");
//		TriggerHelper.HasDealtWithTech(ii, "health_regen_units");
//		TriggerHelper.HasDealtWithTech(ii, "attack_soldiers_will");
//		TriggerHelper.HasDealtWithTech(ii, "armor_hero_01");
//		TriggerHelper.HasDealtWithTech(ii, "fortress_fire");
	}
	for (var iii = 0; iii < numPlayers; iii++)
		this.SpawnCCPlayer(iii);
	print ("spawn"+numPlayers);
	for (	iii = 0; iii < numPlayers; iii++)
			this.get_all_pl_ents(iii)
	this.Defenders();
	
	//this.DoRepeatedly(6 *1000, "retreatUnits", {});
	//this.DoRepeatedly((6+30*time) * (3/difficulty)*1000, "PlaceTreasures2", {});
	try {TriggerHelper.SpawnAndGarrisonAtClasses(1, "CivCentre", "units/cavalry_champion_archer", 1);}
	catch (err){log ("no spawn garr")}
	
	try {TriggerHelper.SpawnAndGarrisonUnits( this.civicCentersplayer, "units/cavalry_champion_archer", 7,10);}
	catch (err)
	{log ("no spawn garr")}
	
	//scaleByMapSize(50, 100);
	this.PlaceArmy()
	this.DoRepeatedly( (3/difficulty)*1000, "AI", {});
	this.DoRepeatedly((120+30*time) * (3/difficulty)*1000, "PlaceArmy", {});
	this.DoRepeatedly((280+20*time) * (3/difficulty)* 1000, "SpawnCCAttackers2", {});
	this.DoRepeatedly(695 * difficulty*1000, "SpawnCCPlayer", {});
	
};

Trigger.prototype.Defenders = function()
{	let point =  "E";
	for (point of this.GetTriggerPoints("G"))
	{
		TriggerHelper.SpawnUnits(point,"units/cart_support_healer_b", 1, 0);
	}
	for (point of this.GetTriggerPoints("F"))
	{
		TriggerHelper.SpawnUnits(point,"units/cart_support_healer_b", 1, 0);
	}
	for (point of this.GetTriggerPoints("H"))
	{
		TriggerHelper.SpawnUnits(point,"units/cart_support_healer_b", 1, 0);
	}
	for (point of this.GetTriggerPoints("I"))
	{
		TriggerHelper.SpawnUnits(point,"units/cart_support_healer_b", 1, 0);
	}
	let healer=TriggerHelper.GetPlayerEntitiesByClass(0, "Healer");
	let ix=0;

	let x_max=0;
	let y_max=0;
	for (let healr of healer)
	{
			let pos=TriggerHelper.GetEntityPosition2D(healr);
		print ("Healer pos"+JSON.stringify(pos));
		ix++;
		if (ix==4)
		{    
			x_max=pos.x;
			y_max=pos.y;
		}
	}
	let anz_part=10;
	mapBounds={"top":x_max,"right":y_max};
	tile_d=this.make_map_bigtile(mapBounds,anz_part);
	point =  "E";
	let patrolPointRef = triggerPointCCAttackerPatrolLeft;
	let triggerPoints = this.GetTriggerPoints(point);
	//TriggerHelper.SpawnUnitsFromTriggerPoints(triggerPoints ,"units/hero_of_the_battlefield_archer", 10, 0);
	for (point of triggerPoints)
	{
		TriggerHelper.SpawnUnits(point,"units/hero_of_the_battlefield_archer", 8, 0);
		TriggerHelper.SpawnUnits(point,"units/superman", 7, 0);
		TriggerHelper.SpawnUnits(point,"units/maur_hero_chanakya", 5, 0);
	}
}

Trigger.prototype.retreatUnits = function()
{	
	let ents_to_heal=[];
	for (l_group of L_entities)
	{	let remove_ind=[];
		for (let ig=0;ig<l_group.length;ig++)
		{
			var cmpHealth = Engine.QueryInterface(ent, IID_Health);
			if (cmpHealth &&cmpHealth.GetHitpoints() < cmpHealth.GetMaxHitpoints()*0.4)
			{			
						ents_to_heal.push(l_group[ig]);
						ProcessCommand(gaulPlayer, {
							"type": "walk",
							"x": 0,
							"z": 100,
							"queued": false,
							"allowCapture": false
						});
						
			}
		}
		for (let i_del=0;i_del<l_group.length;i_del++)
		{
			l_group.array.splice(i_del, 1);
			
		}
		
	}

	return ents_to_heal;
}

Trigger.prototype.get_tile_size = function(mapBounds,anz_part)
{	
	let tile_matrix=[];
	let tile_x_size=Math.floor(mapBounds.right/anz_part);
	let tile_y_size=Math.floor(mapBounds.top/anz_part);
	return [tile_x_size,tile_y_size];
}
Trigger.prototype.make_map_bigtile = function(mapBounds,anz_part)
{	
	let tile_matrix=[];
	let tile_x_size=Math.floor(mapBounds.right/anz_part);
	let tile_y_size=Math.floor(mapBounds.top/anz_part);
	let last_tilsizeX=(tile_x_size*anz_part)-mapBounds.right;
	let last_tilsizeY=(tile_y_size*anz_part)-mapBounds.top;
	
	let x1=0;
	let y1=0;
	let tile_matrix_D={};
	for (let x=14;x<mapBounds.right-tile_x_size;x+=tile_x_size)
	{	
		x1=x+tile_x_size;
		if ((x1+last_tilsizeX)>=mapBounds.right*0.999)
				x1+=-last_tilsizeX;
		for (let y=14;y<mapBounds.top-tile_y_size;y+=tile_y_size)
		{
			y1=y+tile_y_size;
			if ((y1+last_tilsizeY)>=mapBounds.top*0.999)
			{
				y1+=-last_tilsizeY;
				print ("y1+last_tilsizeY)>=mapBounds.top",y1,last_tilsizeY,mapBounds.top)
			}
			//tile_matrix.push([x,y]);
			tile_matrix.push([x,y,x1,y1]);
			//tile_matrix_D[""+x+"_"+y+"_"+x1+"_"+y1]=0;
			//tile_matrix_D[new Set([x,y,x1,y1])]=0;
			//print ("tile_matrix_D"+JSON.stringify(tile_matrix_D));
			//print ("tile_matrix_D"+tile_matrix_D.length);
			//print ("tile_matrix"+tile_matrix.length);

		}
	}
	return tile_matrix;
}

Trigger.prototype.get_troop_strength_tile = function(tile_matrix,ents)
{	
	let healer=TriggerHelper.GetPlayerEntitiesByClass(1, "Healer");
	for (let healr of healer)
		{let pos=TriggerHelper.GetEntityPosition2D(healr);
		print ("Healer pos"+JSON.stringify(pos));}
	let xy=[];
	let xanfang=0;
	let yanfang=0;
	let z=0;
	var xyx1y1=[];
	var ents_to_heal=[];
	var ents_idle=[];
	let posL=[];
	let D_anz_Tile=[];
	let tile_matrix_c=[];
	for (let g=0;g<tile_matrix.length;g+=1)
		tile_matrix_c.push(0);
	let t=new Date().getTime();
	let pos=0;
	for (let ent of ents)
	{
	    let cmpHealth = Engine.QueryInterface(ent, IID_Health);
		let cmpUnitAI = Engine.QueryInterface(ent, IID_UnitAI);
	    try{
	   // print ("cmpUnitAI"+JSON.stringify(TriggerHelper.GetEntityPosition2D(ent)));
	   // print ("cmpUnitAI"+JSON.stringify(cmpUnitAI));
	   // print ("cmpUnitAI"+cmpHealth.GetHitpoints());

	    }
	    catch(err){print ("err"+err)}

		pos=TriggerHelper.GetEntityPosition2D(ent);	

		if (cmpUnitAI && cmpUnitAI.IsIdle())
		{	
			if (cmpHealth &&cmpHealth.GetHitpoints() > cmpHealth.GetMaxHitpoints()*0.9)
			{
				ents_idle.push(ent);
				print ("ents IsIdle cmpUnitAI"+JSON.stringify(cmpHealth.GetHitpoints()));
			}			
		}
		if (cmpHealth &&cmpHealth.GetHitpoints() < cmpHealth.GetMaxHitpoints()*0.8)
		{			
			ents_to_heal.push(ent);
			print ("ents heal cmpUnitAI"+JSON.stringify(cmpHealth.GetHitpoints()));
		}
		posL.push(pos);
		for (let x=0;x<tile_matrix.length;x+=1)
		{		
	
				xyx1y1=tile_matrix[x];
				/* if (xyx1y1==undefined)
				{
					print ("xyx1y1"+JSON.stringify(xyx1y1));
					print ("xyx1y1"+JSON.stringify(tile_matrix_c));
				
				} */
				//print ("xyx1y1"+JSON.stringify(xyx1y1));
				//print ("xyx1y2"+JSON.stringify(pos));
				//print ("xyx1y1"+(xyx1y1));
				//print (pos.x,pos.y);
				//print (xyx1y1);
				if ((pos.x>=xyx1y1[0] && pos.x<xyx1y1[2]) && (pos.y>=xyx1y1[1] && pos.y<xyx1y1[3]))
				{   
					print ("match "+tile_matrix_c[x]+"z "+z+"X "+x);
					tile_matrix_c[x]+=1;
					z++;
				}
		}
	}
	ProcessCommand(gaulPlayer, {
							"type": "walk",
							"x": 100,
							"z": 100,
							"entities": ents_idle,
							"queued": false,
							"allowCapture": false
						});
						
	ProcessCommand(gaulPlayer, {
							"type": "walk",
							"entities": ents_to_heal,
							"x": 500,
							"z": 500,
							"queued": false,
							"allowCapture": false
						});
	let t2=new Date().getTime();
	print ("time"+(t-t2))
	print ("tile_matrix z"+z);
	print ("tile_matrix_c"+JSON.stringify(tile_matrix_c));
	return tile_matrix;
}
Trigger.prototype.pathfinding_formation = function(ents,tile_matrix,starting_tile, target_tile, min_abstand)
{	
	
}

Trigger.prototype.map_of_enemytroops = function(pl_ents)
{	
	let ents_to_heal=[];
	for (let l_group of pl_ents)
	{	let remove_ind=[];
		for (let ig=0;ig<l_group.length;ig++)
		{
			var cmpHealth = Engine.QueryInterface(ent, IID_Health);
			if (cmpHealth &&cmpHealth.GetHitpoints() < cmpHealth.GetMaxHitpoints()*0.4)
			{			
						ents_to_heal.push(l_group[ig]);
						ProcessCommand(gaulPlayer, {
							"type": "walk",
							"x": 0,
							"z": 100,
							"queued": false,
							"allowCapture": false
						});
						
			}
		}
		for (let i_del=0;i_del<l_group.length;i_del++)
		{
			l_group.array.splice(i_del, 1);
		}
		
	}

	return ents_to_heal;
}
Trigger.prototype.sneak_behind_lines = function(ents)
{
	let bound=this.mapBounds.top;
}
Trigger.prototype.get_all_pl_ents = function(playerID)
{	
	let classes=["Archer","Slinger"];
	let ents=TriggerHelper.GetPlayerEntitiesByClass(playerID, classes)
	print ("ents Archer"+ents.length);
	let ents_groups={};
	ents_groups["Archer"]=ents;
	
	classes=["Spear","Pike"];
	ents=TriggerHelper.GetPlayerEntitiesByClass(playerID, classes)
	print ("ents Spear"+ents.length);
	ents_groups["Spear"]=ents;
	return ents_groups;
}
Trigger.prototype.distinctgrops = function(get_all_pl_ents )
{
	
}

Trigger.prototype.walk_half_circle = function(point,targetpiont)
{
	let walkpoints=[];
	let x0=point.x;
	let x1=targetpoint.x;
	let y0=point.y;
	let y1=targetpoint.y;
	
	let firstYmove=y0-(10+10*Math.random());
	let firstXmove=x0-(5*Math.random())+(5*Math.random());
	
	walkpoints.push([firstXmove,firstYmove]);
	
	let Ymove=y0-(10+10*Math.random());
	let Xmove=firstXmove+(5*Math.random())+(5*Math.random());
	
	walkpoints.push([Xmove,Ymove]);
	
	
	
}

Trigger.prototype.FindSweetSpots = function(gaia_ents,pl_ents, point_of_interest)
{
	
	
}
Trigger.prototype.superiority = function(gaia_ents,pl_ents, point_of_interest)
{
	
	
}

Trigger.prototype.PlaceTreasures2 = function()
{
	
	let time = TriggerHelper.GetMinutes();
	var countfunc = t => Math.min(10, Math.max(8, Math.round(15*(t * 0.3*(0.24*difficulty*numPlayers)))));
	let count=countfunc(time);
	print ("PlaceTreasures2");
	//let unitCounts = TriggerHelper.SpawnAndGarrisonAtClasses(0, "CivCentre", "units/cavalry_champion_archer", 1);
	//let unitCounts2 = TriggerHelper.Fses(1, "CivCentre", "units/cavalry_champion_archer", 1);
	//print ("uc"+unitCounts);
	
	//TriggerHelper.SpawnAndGarrisonAtClasses(0, "Fortress", "units/cavalry_champion_archer", 1);
	/* for (let gaiaCC of this.civicCenters)
	{
			TriggerHelper.SpawnGarrisonedUnits(entity, template, count, owner)
	}
	 */
	let spec_TargetClass="";
	let point = pickRandom(["A"]);
	let patrolPointRef = triggerPointCCAttackerPatrolLeft
	let triggerPoints = this.GetTriggerPoints(point);
	let entss=0;
	for (let point of triggerPoints)//Meat units
	{	entss=TriggerHelper.SpawnUnits(point, pickRandom(AttackTempl), count, 0);
		TriggerHelper.SetUnitFormation(0, entss, pickRandom(unitFormations2));
		this.AttackAndPatrol(entss, unitTargetClass, patrolPointRef, "CCAttackers", true)
	}
	
	for (let point of triggerPoints)//Meat units
	{	entss=TriggerHelper.SpawnUnits(point, pickRandom(AttackTempl_Spear), count, 0);
		TriggerHelper.SetUnitFormation(0, entss, pickRandom(unitFormations2));
		spec_TargetClass="Cavalry"
		this.AttackAndPatrol(entss, unitTargetClass, patrolPointRef, "CCAttackers", true)
	} 
	
 	point = "B";
	triggerPoints = this.GetTriggerPoints(point);
	for (point of triggerPoints)
	{	entss=TriggerHelper.SpawnUnits(point, pickRandom(AttackTempl3), count, 0);
		TriggerHelper.SetUnitFormation(0, entss, pickRandom(unitFormations2));
		this.AttackAndPatrol(entss, unitTargetClass, patrolPointRef, "CCAttackers", true)
	}
	L_entities.push(entss);
	point = "C";
	triggerPoints = this.GetTriggerPoints(point);
	for (point of triggerPoints)
	{	entss=TriggerHelper.SpawnUnits(point, pickRandom(AttackTempl2), count, 0);
		TriggerHelper.SetUnitFormation(0, entss, pickRandom(unitFormations2));
		this.AttackAndPatrol(entss, unitTargetClass, patrolPointRef, "CCAttackers", true)
	}
	L_entities.push(entss);
	point = "D";
	triggerPoints = this.GetTriggerPoints(point);
	for (point of triggerPoints)
	{	entss=TriggerHelper.SpawnUnits(point, pickRandom([pickRandom(AttackTempl4),pickRandom(AttackTempl5)]), Math.floor(count/2), 0);
		TriggerHelper.SetUnitFormation(0, entss, pickRandom(unitFormations2));
		this.AttackAndPatrol(entss, unitTargetClass, patrolPointRef, "CCAttackers", true)
	} 
	L_entities.push(entss);
	
	//TriggerHelper.SpawnUnits(point, pickRandom(treasures), 1, 0);
};

Trigger.prototype.AI = function(){
	//let ents=TriggerHelper.GetAllPlayersEntities();
	let ents=TriggerHelper.GetPlayerEntitiesByClass(0, "Unit");
	let troop_strength_tiles=this.get_troop_strength_tile(tile_d,ents);
}
Trigger.prototype.PlaceArmy = function()
{
	/* let ents=TriggerHelper.GetAllPlayersEntities();
	let archer=TriggerHelper.GetPlayerEntitiesByClass(1, "Archer");
	let inf=TriggerHelper.GetPlayerEntitiesByClass(1, "Infantry");
	print ("ents length"+ents.length);
	print ("ents length"+archer.length);
	print ("ents length"+inf.length);
	print ("ents length"+TriggerHelper.GetPlayerEntitiesByClass(0, "Fortress").length);
	print ("ents length"+TriggerHelper.GetPlayerEntitiesByClass(0, "Unit").length);
	print ("ents length"+TriggerHelper.GetPlayerEntitiesByClass(1, "Hero").length);
	print ("pos"+JSON.stringify(TriggerHelper.GetEntityPosition2D(ents[0])));
	print ("pos"+JSON.stringify(TriggerHelper.GetMapSizeTerrain()));
	print ("pos"+JSON.stringify(TriggerHelper.GetMapSizeTiles()));
	let anz_part=10;
	let mapBounds={"top":1000,"right":1000};
	let tile_d=this.make_map_bigtile(mapBounds,anz_part);
	//print ("tile_d"+JSON.stringify(tile_d));
	let troop_strength_tiles=this.get_troop_strength_tile(tile_d,ents);
	print ("troop_strength_tile"+JSON.stringify(troop_strength_tiles));
	 */
	
	let time = TriggerHelper.GetMinutes();
	var countfunc = t => Math.min(10, Math.max(8, Math.round(15*(t * 0.3*(0.24*difficulty*numPlayers)))));
	let count=countfunc(time);
	print ("army2");
	//let unitCounts = TriggerHelper.SpawnAndGarrisonAtClasses(0, "CivCentre", "units/cavalry_champion_archer", 1);
	//let unitCounts2 = TriggerHelper.SpawnAndGarrisonAtClasses(1, "CivCentre", "units/cavalry_champion_archer", 1);
	//print ("uc"+unitCounts);
	//TriggerHelper.SpawnAndGarrisonAtClasses(0, "Fortress", "units/cavalry_champion_archer", 1);
	/* for (let gaiaCC of this.civicCenters)
	{
			TriggerHelper.SpawnGarrisonedUnits(entity, template, count, owner)
	}
	 */
	let spec_TargetClass="";
	let point = pickRandom(["A"]);
	let patrolPointRef = triggerPointCCAttackerPatrolLeft
	let triggerPoints = this.GetTriggerPoints(point);
	let entss=0;

	
	for (let point of triggerPoints)//Meat units
	{	entss=TriggerHelper.SpawnUnits(point, pickRandom(AttackTempl_Spear), count, 0);
		TriggerHelper.SetUnitFormation(0, entss, pickRandom(unitFormations2));
		spec_TargetClass="Cavalry"
		this.AttackAndPatrol(entss, unitTargetClass, patrolPointRef, "CCAttackers", true)
	} 
	
 	point = "B";
	triggerPoints = this.GetTriggerPoints(point);
	for (point of triggerPoints)
	{	entss=TriggerHelper.SpawnUnits(point, pickRandom(AttackTempl_Cav), count, 0);
		TriggerHelper.SetUnitFormation(0, entss, pickRandom(unitFormations2));
		spec_TargetClass="Archer+Javelin"
		this.AttackAndPatrol(entss, unitTargetClass, patrolPointRef, "CCAttackers", true)
	}
	
	
	//TriggerHelper.SpawnUnits(point, pickRandom(treasures), 1, 0);
	
};
Trigger.prototype.log = function(txt)
{
 	if (!debugLog)
		return;
	print("DEBUG [" + Math.round(TriggerHelper.GetMinutes()) + "]  " + txt + "\n");
};
Trigger.prototype.Evade = function(entities)
{
	let pos =TriggerHelper.GetEntityPosition2D(entities[0]);// pos first member of formation
	let enymies=[];
	TriggerHelper.GetEntitiesByPlayer(1);
	TriggerHelper.MatchEntitiesByClass(enymies, "!Healer").filter(TriggerHelper.IsInWorld);
	
	
	
};
Trigger.prototype.AttackAndPatrol = function(entities, targetClass, triggerPointRef, debugName, attack)
{
	if (!entities.length)
		return;

	let attackers = TriggerHelper.MatchEntitiesByClass(entities, "!Healer").filter(TriggerHelper.IsInWorld);
	if (!attackers.length)
		return;

	let targets = TriggerHelper.MatchEntitiesByClass(TriggerHelper.GetAllPlayersEntities(), targetClass);
	this.civicCentersplayer=new Set(TriggerHelper.GetPlayerEntitiesByClass(1, "CivCentre"));
	//let civicCentersplayer_pos=TriggerHelper.GetEntityPosition2D((TriggerHelper.GetPlayerEntitiesByClass(1, "CivCentre")));
	//print ("XXX"+civicCentersplayer_pos.x);
	//print (JSON.stringify(civicCentersplayer_pos));
	let closestTarget;
	let minDistance = Infinity;
	
	let targetClassArcher="Archer+Slinger+Javelin";
	//targetClass=targetClassArcher;
	
	
	for (let target of targets)
	{

		let targetDistance = DistanceBetweenEntities(attackers[0], target);
		if (targetDistance < minDistance)
		{
			closestTarget = target;
			minDistance = targetDistance;
			//print ("closestTarget"+JSON.stringify(targetDistance));
		}
	}
	
	
		//DistanceBetweenEntities(ship, this.shipTarget[ship].ungarrisonPoint)
		/* ProcessCommand(gaulPlayer, {
			"type": "attack-walk",
			"entities": attackers,
			"x": civicCentersplayer_pos.x-Math.min(0, -20* Math.random()),
			"z": civicCentersplayer_pos.z-Math.min(0, -20* Math.random()),
			"targetClasses": {
				"attack": targetClass
			},
			"queued": true,
			"allowCapture": false
		}); */
	let targetPos = TriggerHelper.GetEntityPosition2D(closestTarget)
	//print ("targetPos.x",targetPos.x);
	if (targetPos&&closestTarget)
	{
		
		ProcessCommand(gaulPlayer, {
			"type": "attack-walk",
			"entities": attackers,
			"x": targetPos.x,//200,//civicCentersplayer_pos.x,
			"z": targetPos.y,//civicCentersplayer_pos.z,
			"targetClasses": {
				"attack": targetClass
			},
			"queued": true,
			"allowCapture": false
		});
	}
	
	
	/* let patrolTargets = shuffleArray(this.GetTriggerPoints(triggerPointRef)).slice(0, 4);

	for (let patrolTarget of patrolTargets)
	{
		let targetPos = TriggerHelper.GetEntityPosition2D(patrolTarget);
		ProcessCommand(gaulPlayer, {
			"type": "attack-walk",
			"entities": attackers,
			"x": targetPos.x,
			"z": targetPos.y,
			"targetClasses": {
				"attack": targetClass
			},
			"queued": true,
			"allowCapture": false
		});
	} */
};

Trigger.prototype.SetDisableTemplates = function()
{
	for (let i = 1; i < TriggerHelper.GetNumberOfPlayers(); ++i)
	{
		let cmpPlayer = QueryPlayerIDInterface(i);
		cmpPlayer.SetDisabledTemplates(disabledTemplates(cmpPlayer.GetCiv()));
	}
};

Trigger.prototype.OnOwnershipChanged = function(data)
{
	if (data.entity == this.playerCivicCenter[data.from])
	{
		this.playerCivicCenter[data.from] = undefined;

		TriggerHelper.DefeatPlayer(
			data.from,
			markForTranslation("%(player)s has been defeated (lost civic center)."));
	}
	else if (data.entity == this.treasureFemale[data.from])
	{
		this.treasureFemale[data.from] = undefined;
		Engine.DestroyEntity(data.entity);
	}
};
{
	let cmpTrigger = Engine.QueryInterface(SYSTEM_ENTITY, IID_Trigger);

	cmpTrigger.treasureFemale = [];
	cmpTrigger.playerCivicCenter = [];
	cmpTrigger.gaiaHeroes = [];

	cmpTrigger.RegisterTrigger("OnInitGame", "InitSurvival", { "enabled": true });
	cmpTrigger.RegisterTrigger("OnOwnershipChanged", "OnOwnershipChanged", { "enabled": true });
}

